package game

type Identifiable struct {
    id int
    name string
}

func (item *Identifiable) getId() int {
    return item.id
}

func (item *Identifiable) getName() string {
    return item.name
}

//Really this is MapObject, but htis name is ugly
type Mob struct {
    Identifiable
    Char char
    X int
    Y int
    Name string
    Color MapColor
    BgColor MapColor
    BlocksPass bool
}

type Monster struct {
    *Mob
    Waypoints [][2]int
    //*AiInstance
    //*Fighter
    BackPack MonsterInventory
    Size int
    Weight int
}

type MonsterInventory struct {
    MaxSize int
    MaxWeight float32
    Content []*Item
}

type Item struct {
    *Mob
    Weight float32
}

func (me Item) Pickup(carrier *Monster) bool {
    carrier.BackPack.Content = append(carrier.BackPack.Content, &me)
    return State.Level.Remove(me.Mob)
}

func (me Item) Drop(carrier *Monster) bool {
    State.Level.Mobs = append(State.Level.Mobs, me.Mob)
    return DeleteFromItemSlice(carrier.BackPack.Content, &me)
}